var async = require('async');
module.exports = {
    '@tags': ['pd_version'],

    before: function (client) {
        client
            .url('http://localhost:3000')
            .waitForElementVisible('#topmenu', 1000);
    },

    after: function (client) {
        client.end();
    },

    /**
     * Test: 4-001
     * Expects:
     *  - Preferences dialog will appear with 6 buttons
     */
    '4-001': function (client) {
        var preferenceTest = client.page.preferenceManagement();

        async.series([
            function (callback) {
                preferenceTest.expect.element('body').to.be.present;
                callback();
            },
            function (callback) {
                preferenceTest.openDialog(function () {
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@preferenceDialog').to.be.visible;
                callback();
            },
            function (callback) {
                // 4-001
                preferenceTest.expect.element('@packagesBtn').to.be.visible;
                preferenceTest.expect.element('@displayBtn').to.be.visible;
                preferenceTest.expect.element('@versionBtn').to.be.visible;
                preferenceTest.expect.element('@resetBtn').to.be.visible;
                preferenceTest.expect.element('@tutorialBtn').to.be.visible;
                preferenceTest.expect.element('@environmentBtn').to.be.visible;
                callback();
            }
        ], function (err, stdout) {

        });
    },

    /**
     * Test: 4-002
     * Expects:
     *  - Versions will display.
     *   "ASIO-Plugin 2.0.0 ASIO Driver Technology by Steinberg Media Technologies
     *   HARK 2.2.0
     *   HARK-SSS 2.2.0
     *   HARK-Python 2.2.0".
     *  This is a sample output
     */
    '4-002': function (client) {
        var preferenceTest = client.page.preferenceManagement();

        async.series([
            function (callback) {
                preferenceTest.clickVersionButton();
                callback();
            },
            function (callback) {
                // 4-002
                preferenceTest.expect.element('@versionDialog').to.have.text.that.contains('HARK 2');
                callback();
            }
        ], function (err, stdout) {

        });

        client.end();
    }
}